/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <gtk/gtk.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include "main.h"
#include "images/icon.xpm"

static void on_Close_activate(GtkWidget *w, gpointer data)
{
	((Bounds*)data)->hide();
}

static gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	((Bounds*)data)->hide();
	return (TRUE); 
}

Bounds::Bounds(Main *m)
{
	main = m;
	create();
}

Bounds::~Bounds()
{
}

void Bounds::create()
{
  bounds = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (bounds), "Network Bounds");
  gtk_widget_realize (bounds);
	window_icon(bounds, icon_xpm);
	gdk_window_set_icon_name(bounds->window, "Bounds");
	gtk_signal_connect(GTK_OBJECT(bounds), "delete_event",
		GTK_SIGNAL_FUNC(delete_event), this);

  vbox13 = gtk_vbox_new (FALSE, 4);
  gtk_widget_show (vbox13);
  gtk_container_add (GTK_CONTAINER (bounds), vbox13);
  gtk_container_set_border_width (GTK_CONTAINER (vbox13), 4);

  hbox8 = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox8, TRUE, TRUE, 0);

  vbox15 = gtk_vbox_new (FALSE, 4);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox15, TRUE, TRUE, 0);

  scrolledwindow18 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow18);
  gtk_box_pack_start (GTK_BOX (vbox15), scrolledwindow18, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow18, 160, 100);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow18), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist17 = gtk_clist_new (1);
  gtk_widget_show (clist17);
  gtk_container_add (GTK_CONTAINER (scrolledwindow18), clist17);
  gtk_clist_set_column_width (GTK_CLIST (clist17), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist17));

  label30 = gtk_label_new ("Community Name");
  gtk_widget_show (label30);
  gtk_clist_set_column_widget (GTK_CLIST (clist17), 0, label30);
  gtk_misc_set_alignment (GTK_MISC (label30), 7.45058e-09, 0.5);

  scrolledwindow20 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow20);
  gtk_box_pack_start (GTK_BOX (vbox15), scrolledwindow20, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow20, -2, 100);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow20), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist19 = gtk_clist_new (1);
  gtk_widget_show (clist19);
  gtk_container_add (GTK_CONTAINER (scrolledwindow20), clist19);
  gtk_clist_set_column_width (GTK_CLIST (clist19), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist19));

  label33 = gtk_label_new ("Subnet / Mask");
  gtk_widget_show (label33);
  gtk_clist_set_column_widget (GTK_CLIST (clist19), 0, label33);
  gtk_misc_set_alignment (GTK_MISC (label33), 7.45058e-09, 0.5);

  entry4 = gtk_entry_new ();
  gtk_widget_show (entry4);
  gtk_box_pack_start (GTK_BOX (vbox15), entry4, FALSE, FALSE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry4), "public");

  hbox10 = gtk_hbox_new (TRUE, 4);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox15), hbox10, FALSE, TRUE, 0);

  button13 = gtk_button_new_with_label ("Add");
  gtk_widget_show (button13);
  gtk_box_pack_start (GTK_BOX (hbox10), button13, TRUE, TRUE, 0);
  gtk_widget_set_usize (button13, 80, -2);

  button14 = gtk_button_new_with_label ("Delete");
  gtk_widget_show (button14);
  gtk_box_pack_start (GTK_BOX (hbox10), button14, TRUE, TRUE, 0);
  gtk_widget_set_usize (button14, 80, -2);

  button10 = gtk_button_new_with_label ("Close");
  gtk_widget_show (button10);
  gtk_box_pack_start (GTK_BOX (hbox10), button10, TRUE, TRUE, 0);
  gtk_widget_set_usize (button10, 80, -2);

  gtk_signal_connect (GTK_OBJECT (button10), "clicked", GTK_SIGNAL_FUNC (on_Close_activate), this);
}

void Bounds::show()
{
	gtk_widget_show(bounds);
	gdk_window_raise(bounds->window);
}

void Bounds::hide()
{
	gtk_widget_hide(bounds);
}

