/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <string.h>
#include <time.h>
#include "main.h"

void window_icon(GtkWidget *widget, char **filename)
{
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;
  GtkWidget *pixmap;

	gdkpixmap = gdk_pixmap_create_from_xpm_d(widget->window, &mask,
  	&widget->style->bg[GTK_STATE_NORMAL], (gchar **)filename);
  pixmap = gtk_pixmap_new(gdkpixmap, mask);
	gtk_widget_show(pixmap);
	gdk_window_set_icon(widget->window, pixmap->window, gdkpixmap, mask);
  gdk_pixmap_unref(gdkpixmap);
  gdk_bitmap_unref(mask);
}

GtkWidget *create_pixmap(GtkWidget *widget, char **filename)
{
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;
  GtkWidget *pixmap;

	gdkpixmap = gdk_pixmap_create_from_xpm_d(widget->window, &mask,
  	&widget->style->bg[GTK_STATE_NORMAL], (gchar **)filename);
  if (gdkpixmap == NULL)
    return (GtkWidget*)NULL;
  pixmap = gtk_pixmap_new(gdkpixmap, mask);
	gtk_widget_show(pixmap);
  gdk_pixmap_unref(gdkpixmap);
  gdk_bitmap_unref(mask);

  return pixmap;
}

GdkPixmap *load_pixmap(GtkWidget *widget, char *filename)
{
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;

	gdkpixmap = gdk_pixmap_create_from_xpm(widget->window, &mask,
  	&widget->style->bg[GTK_STATE_NORMAL], (gchar *)filename);

  return gdkpixmap;
}

void set_stipple(GtkWidget *widget, GdkGC *gc, char **filename)
{
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;

	gdkpixmap = gdk_pixmap_create_from_xpm_d(widget->window, &mask,
  	&widget->style->bg[GTK_STATE_NORMAL], (gchar **)filename);
	gdk_gc_set_stipple(gc, gdkpixmap);
}

void clist_pixmap(GtkWidget *widget, GtkCList *clist, gint row, gint column, char **filename)
{
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;

	gdkpixmap = gdk_pixmap_create_from_xpm_d(widget->window, &mask,
  	&widget->style->bg[GTK_STATE_NORMAL], (gchar **)filename);
  if (gdkpixmap == NULL) return;

	gtk_clist_set_pixmap(clist, row, column, gdkpixmap, mask);

  gdk_pixmap_unref(gdkpixmap);
  gdk_bitmap_unref(mask);
}

