/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef MONITOR_H
#define MONITOR_H 1

#include "list.h"

class Main;
class Data;
class Visual;
class Diagram;
class Monitor
{
	public:
		Monitor(Main *m);
		~Monitor();

		void draw();
		void create();
		void show();
		void hide();
		void draw_bb(GdkPixmap *w);
		void mouse_stuff(GdkEventType type, int x, int y, int state, int bttn, guint32 time);
		void popup_menu1();
		void popup_menu2();
		void popup_menu3();
		void select_all(int val);
		void cloud(int val);
		void clouda(int val);
		void search();
		void fit_to_window();
		void fit_to_selected();
		void cloud_ones();
		void details_window();
		void machine_window();
		void del();
		void add();
		void zoomin(double orig, double nw);

		Main *main;
		Diagram *diagram;
		gint width, height;								// size of viewport
		gint ww, hh;											// current visible size
		GdkPixmap *canvas;
		char viewname[256];
		char viewfile[256];

		int colours, grid, snap, showones, animate, ants, show_machines;
		double zoom;
		gint animate_tag;
		gint ants_tag;
		int animate_frame; 	// used for marching ants
		int row;

		GdkGC *gc, *xgc;
		int mode;		// drag/select/etc.
		int button;
		int obx, oby;		// origin
		int bbx, bby;
		int nx, ny;
		int ox, oy;
		Visual *current;

		GtkWidget *mainmenu[10];
		GtkWidget *filemenu[10];
		GtkWidget *viewmenu[10];
		GtkWidget *netwmenu[10];
		GtkWidget *optnmenu[10];
		GtkWidget *wndwmenu[10];
		GtkWidget *helpmenu[10];

  GtkWidget *hbox13;
  GtkWidget *vbox17;
  GtkWidget *vbox19;
  GtkWidget *toolbar3;
  GtkWidget *frame2;
  GtkWidget *frame4;
  GtkWidget *hbox16;
  GtkWidget *hscale1;
  GtkWidget *frame1;
  GtkWidget *hbox15;
  GtkWidget *button36;
  GtkWidget *frame3;
  GtkWidget *vbox18;
  GtkWidget *scrolledwindow19;
  GtkWidget *clist18;
  GtkWidget *label32;
  GtkWidget *label34;
  GtkWidget *entry5;
  GtkWidget *hbox14;
  GtkWidget *hbox52;
  GtkWidget *hbox53;
  GtkWidget *button17;
  GtkWidget *button18;
  GSList *vbox18_group;
  GtkWidget *radiobutton1;
  GtkWidget *radiobutton2;
  GtkWidget *radiobutton3;
	GtkObject *hscale1_adj;

		GtkWidget *popup;
		GtkWidget *popup2;
		GtkWidget *popup3;
		GtkWidget *window1;
		GtkWidget *vbox1;
		GtkWidget *vbox3;
		GtkWidget *vpaned2;
		GtkWidget *scrolledwindow2;
		GtkWidget *scrolledwindow3;
		GtkWidget *scrolledwindow4;
		GtkWidget *drawingarea2;
		GtkWidget *drawingarea20;
		GtkWidget *text2;
		GtkWidget *toolbar1;
		GtkWidget *button5;
		GtkWidget *button2;
		GtkWidget *button3;
		GtkWidget *button6;
		GtkWidget *button9;
		GtkWidget *button10;
		GtkWidget *label11;
		GtkWidget *entry2;
		GtkWidget *clist3;
		GtkWidget *clist4;
		GtkWidget *notebook1;
		GtkWidget *table1;
		GtkWidget *viewport1;
		GtkWidget *vscrollbar1;
		GtkWidget *hscrollbar1;
		GtkObject *adjw, *adjh;

		GtkWidget *pixmap[50];
};

#endif

