/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef INTERFACE_H
#define INTERFACE_H 1

#include <stdio.h>
#include "list.h"
#include "misc.h"

class Network;
class Router;
class Interface
{
	public:
		Interface();
		~Interface();

		void clear();
		void print();
		void save(FILE *f);
		void savexml(xmlNodePtr xmlnode);
		void load(FILE *f);
		void loadxml(xmlNodePtr xmlnode);

		int index;							// 4 bytes
		unsigned char mac[6];		// 6 bytes
		unsigned long speed;		// 8 bytes
		int type;								// 4 bytes   ethernet, fddi, serial
		int status;							// 1 bit     on, off
		char descr[65];					// 64 bytes
		char port[65];					// 64 bytes
		List ip_addresses;

		int len;								// optimal length for autoplacement algorithm
		int vlan;								// used during building network

		Network *network;
		Router *router;
};

#endif

