/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef MACHINE_H
#define MACHINE_H 1

#include <stdio.h>
#include <sys/time.h>
#include "ipaddress.h"
#include "list.h"
#include "misc.h"

class Network;
class Subnet;
class Machine
{
	public:
		Machine();
		~Machine();

		void clear();
		void print();
		void save(FILE *f);
		void load(FILE *f);
		void match(char *string);
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode);

		char name[65];				// 64 bytes   xander
		IPAddress ip;					// 4 bytes    128.240.3.253
		time_t last_seen;			// when was the machine last seen on the network
		char location[65];		// 64 bytes   Claremont Tower
		char descr[65];				// 64 bytes   RM Accel 450MHz
		char contact[65];			// 64 bytes   etherstaff
		unsigned char mac[6];
		int registered;				// is the machine registered in the inventory
		int place;						// is the location the real location
		int find;
		Network *network;
};

#endif

