/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef ROUTER_H
#define ROUTER_H 1

#include <stdio.h>
#include <sys/time.h>
#include "visual.h"
#include "list.h"
#include "ipaddress.h"
#include "misc.h"

class Router : public Visual
{
	public:
		Router();
		~Router();

		void clear();
		void print();
		void save(FILE *f);
		void savexml(xmlNodePtr xmlnode);
		void load(FILE *f);
		void loadxml(xmlNodePtr xmlnode);
		void match(char *string);

		IPAddress pingname;
		char name[65];				// 64 bytes   xander
		time_t last_seen;			// when was the machine last seen on the network
		char location[65];		// 64 bytes   Claremont Tower
		char community[65];		// 64 bytes   public
		char descr[65];				// 64 bytes   Cisco Catalyst 1924 XL
		char contact[65];			// 64 bytes   etherstaff
		int status;						// can we see the machine on the network
		int registered;				// is the machine registered in the inventory
		int matrix;						// is there a matrix group for this switch
		List interfaces;
};

#endif

/* Things that are local to client view

	status
	x
	y
	w
	h
	selected
	show
	visited
	find
	fix

*/

