/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef SUBNET_H
#define SUBNET_H 1

#include <stdio.h>
#include "ipaddress.h"
#include "misc.h"

class Subnet
{
	public:
		Subnet();
		~Subnet();

		void clear();
		void save(FILE *f);
		void load(FILE *f);
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode);
		void print();
		void match(char *string);

		char name[65];					// 64 bytes
		IPAddress gateway;			// 4 bytes
		IPAddress ip;						// 4 bytes
		int mask;								// 4 bytes

		int find;								// used for searching
};

#endif

