/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef DEVICE_H
#define DEVICE_H 1

#include "misc.h"
#include "ipaddress.h"

class IPAddr;
class Iface;
class Address;
class Mac;
class Route;
class Device
{
	public:
		Device();

		void clear();
		void print();

		IPAddress pingname;
		char name[65];				// 64 bytes   xander
		char community[65];		// 64 bytes   public
//		IPAddress ip;					// 4 bytes    128.240.3.253
		char type;						// 1 byte     m - machine, r - router, s - switch
		time_t grab_time;

		int num_interfaces;
		int num_addresses;
		int num_macs;
		int num_routes;
		int num_ips;
		Iface *interfaces;
		Address *addresses;
		Mac *macs;
		Route *routes;
		IPAddr *ips;
};

#endif

