/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <pwd.h>
#include "ping.h"
#include "misc.h"

Ping::Ping()
{
}

Ping::~Ping()
{
}

void Ping::main()
{
	FILE *f;
	struct stat statbuf;
	struct passwd *p;
	char mapdir[256];
	char buf[256], datestamp[256];
	char host[256], ip[256], comm[256];
	IPAddress tmpip;
	PingDevice *pd;
	Link *ln;
	float ts;

	p = getpwuid(getuid());
	sprintf(mapdir, "%s/%s", p->pw_dir, HOME_DIR);

	sprintf(buf, "%s/logs", mapdir);
	if (stat(buf, &statbuf) == -1) mkdir(buf, 493); // rwxr xr x

	sprintf(buf, "%s/devices", mapdir);
	f = fopen(buf, "r");
	if (!f) return;
	while(fscanf(f, "%[^\n]\n", buf)==1)
	{
		sscanf(buf, "%[^,],%[^,],%[^\n]", host, ip, comm);
		pd = new PingDevice();
		strcpy(pd->name, host);
		pd->pingname.set(ip);
		pd->flag = 0;
		devices.tag(pd);
	}
	fclose(f);

	sprintf(buf, "%s/ping.old", mapdir);
	f = fopen(buf, "r");
	if (!f) return;
	fscanf(f, "%[^\n]\n", buf); // the date stamp
	while(fscanf(f, "%[^ ] (%f ms)\n", buf, &ts)==2)
	{
		tmpip.set(buf);
		for (ln=devices.get_head(); ln!=NULL; ln=ln->next)
		{
			pd = (PingDevice*) ln->item;
			if (tmpip.compare(pd->pingname))
				pd->flag += 1;
		}
	}
	fclose(f);

	sprintf(buf, "%s/ping", mapdir);
	f = fopen(buf, "r");
	if (!f) return;
	fscanf(f, "%[^\n]\n", datestamp); // the date stamp
	while(fscanf(f, "%[^ ] (%f ms)\n", buf, &ts)==2)
	{
		tmpip.set(buf);
		for (ln=devices.get_head(); ln!=NULL; ln=ln->next)
		{
			pd = (PingDevice*) ln->item;
			if (tmpip.compare(pd->pingname))
				pd->flag += 2;
		}
	}
	fclose(f);

	sprintf(buf, "%s/logs/alive", mapdir);
	f = fopen(buf, "a");
	if (!f) return;

	for (ln=devices.get_head(); ln!=NULL; ln=ln->next)
	{
		pd = (PingDevice*) ln->item;
		pd->pingname.sprint(buf);
		switch (pd->flag)
		{
			case 1: fprintf(f, "%s: Device %s (%s) is down\n",
								datestamp, pd->name, buf); break;
			case 2: fprintf(f, "%s: Device %s (%s) is up\n",
								datestamp, pd->name, buf); break;
			default: break;
		}
	}
	fclose(f);
}

